`include "nettype.v"
`include "stddef.v"
`include "global_config.v"

`include "bus.v"

`timescale 1ns/1ns
module bus_arbiter_tb;

    reg clk, reset,m0_req_,m1_req_,m2_req_,m3_req_; 
    wire m0_grnt_,m1_grnt_,m2_grnt_,m3_grnt_;

    bus_arbiter ba1(.clk(clk),.reset(reset)
        ,.m0_req_(m0_req_),.m0_grnt_(m0_grnt_)
        ,.m1_req_(m1_req_),.m1_grnt_(m1_grnt_)
        ,.m2_req_(m2_req_),.m2_grnt_(m2_grnt_)
        ,.m3_req_(m3_req_),.m3_grnt_(m3_grnt_)
        );

    initial begin
        m0_req_ = `DISABLE_;
        m1_req_ = `DISABLE_;
        m2_req_ = `DISABLE_;
        m3_req_ = `DISABLE_;
    end
    initial begin
        clk             = 0;
        forever #10 clk = ~clk;
    end
    initial begin
        reset = `RESET_ENABLE;
        #15 reset = `RESET_DISABLE;
        #20 m1_req_ = `ENABLE_;
        #260 m1_req_ = `DISABLE_;
    end
    initial begin
        #60 m2_req_ = `ENABLE_;
        #460 m2_req_ = `DISABLE_;
        #200 $finish;
    end

    initial
    begin            
        $dumpfile("bus_arbiter_tb.vcd");        //生成的vcd文件名称
        $dumpvars(0, bus_arbiter_tb);    //tb模块名称
    end 
endmodule